		.title	TASL for X680x0 <mode 0> (8x16dot,96x32char)


* Include File -------------------------------- *

		.include	tasl.h
		.include	eririn.mac
		.include	iocscall.mac


* Fixed Number -------------------------------- *

DOT_PER_CHAR:	.equ	8
LINE_PER_CHAR:	.equ	16
MAX_WIDTH:	.equ	768/DOT_PER_CHAR
MAX_LINE:	.equ	512/LINE_PER_CHAR
MAX_WIDTH_L:	.equ	640/DOT_PER_CHAR
MAX_LINE_L:	.equ	400/LINE_PER_CHAR

VTXTBUF_SIZE:	.equ	MAX_WIDTH*MAX_LINE*2
FONTBUF_SIZE:	.equ	(DOT_PER_CHAR/8)*LINE_PER_CHAR*$e0


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even
tasl0::
		.dc	MAX_WIDTH  ,MAX_LINE
		.dc	MAX_WIDTH_L,MAX_LINE_L
		.dc.l	VTXTBUF_SIZE*2+FONTBUF_SIZE
		.dc	tasl0_init_buf-tasl0
		.dc	tasl0_draw_text-tasl0


* obt@ ------------------------------ *
* zeLXgNAyуtHgǂݍ.
* WORK_BUFPTRɊmۂ̃AhXݒ肳ČĂяo.
* KvɉĊeobt@. zeLXgobt@
* AhXWORK_VTXTBUFɁAtHgǂݍ݃obt@̃AhX
* WORK_FNTBUFɕۑĂ悢.
* in	a6.l	VXe[N
* out	----
* break	----

tasl0_init_buf:
		PUSH	d0-d7/a0-a5
		movea.l	(WORK_BUFPTR,a6),a1

;zeLXgobt@
		move.l	a1,(WORK_VTXTBUF,a6)
		move.l	#SPACE<<16+SPACE,d0
		tst.b	(WORK_OPT_R,a6)
		beq	@f
		move.l	#NOT_A_CHAR<<16+NOT_A_CHAR,d0
@@:		move	#VTXTBUF_SIZE*2/16-1,d1
@@:
	.rept	4
		move.l	d0,(a1)+
	.endm
		dbra	d1,@b

;tHgǂݍ
		TO_SUPER
		move.l	a1,(WORK_FNTBUF,a6)
		moveq	#0,d3
		move	#$e0-1,d4
		movea.l	(_FNTADR*4+$400),a3
		suba.l	a5,a5
@@:
		move	d3,d1			;R[h
		moveq	#8,d2			;TCY
		jsr	(a3)
		movea.l	d0,a0
	.rept	(DOT_PER_CHAR/8)*LINE_PER_CHAR/4
		move.l	(a0)+,(a1)+
	.endm
		addq	#1,d3
		dbra	d4,@b
		TO_USER

		tst.b	(WORK_OPT_R,a6)
		beq	tasl0_init_buf_normal

;tHg](Sp͕\xɔ])
		movea.l	(WORK_FNTBUF,a6),a1
		move	#FONTBUF_SIZE/16-1,d0
@@:
	.rept	16/4
		not.l	(a1)+
	.endm
		dbra	d0,@b
tasl0_init_buf_normal:
		POP	d0-d7/a0-a5
		rts


* eLXg ---------------------------- *
* (WORK_TEXTSIDE,a6)Ƌt̉ʂɕ.
* X[p[oCU[hŌĂяo.
* WX^͑SĔj󂵂Ă܂Ȃ.
* in	d6.l	-1
*	d7.l	s-1
*	a0.l	eLXgf[^̃AhX
*	a4.l	tHgobt@̃AhX
*	a5.l	zeLXgobt@̃AhX
* out	----
* break	????

tasl0_draw_text:
		lea	(TVRAM),a3
		adda.l	(WORK_DISP_X,a6),a3
		move.l	(WORK_DISP_Y,a6),d0
		mulu	#128*LINE_PER_CHAR,d0
		adda.l	d0,a3			;`AhX()

		tst.b	(WORK_TEXTSIDE,a6)
		bne	@f
		adda.l	#128*512,a3
		lea	(VTXTBUF_SIZE,a5),a5
@@:
		bra	tasl0_draw_text_start

tasl0_draw_text_y_loop:
		POP	a0/a3/a5
		lea	(128*LINE_PER_CHAR,a3),a3
		lea	(MAX_WIDTH*2,a5),a5
		moveq	#LF,d0
@@:		cmp.b	(a0)+,d0
		bne	@b
tasl0_draw_text_start:
		PUSH	a0/a3/a5
		adda.l	(WORK_SKIP_X,a6),a0
		move	d6,d5
tasl0_draw_text_x_loop:
		moveq	#0,d1
		move.b	(a0)+,d1
		bpl	tasl0_draw_text_sb
		cmpi.b	#$a0,d1
		bcs	tasl0_draw_text_mb
		cmpi.b	#$e0,d1
		bhi	tasl0_draw_text_mb
tasl0_draw_text_sb:
		cmp	(a5)+,d1
		beq	tasl0_draw_text_sb_skip

		VTXT_MISS
		move	d1,(-2,a5)
		lsl	#4,d1
		lea	(a4,d1.w),a1
i:=0
		move.b	(a1)+,(a3)+
	.rept	16-1
		i:=i+128
		move.b	(a1)+,(i-1,a3)
	.endm
		dbra	d5,tasl0_draw_text_x_loop
		dbra	d7,tasl0_draw_text_y_loop
tasl0_draw_text_end:
		POP	a0/a3/a5
		rts
tasl0_draw_text_sb_skip:
		VTXT_HIT
		addq.l	#1,a3
		dbra	d5,tasl0_draw_text_x_loop
		dbra	d7,tasl0_draw_text_y_loop
		bra	tasl0_draw_text_end

tasl0_draw_text_mb_skip:
		VTXT_HIT
		addq.l	#2,a3
		addq.l	#2,a5
		dbra	d5,tasl0_draw_text_x_loop
		dbra	d7,tasl0_draw_text_y_loop
		bra	tasl0_draw_text_end

tasl0_draw_text_mb:
		subq	#1,d5
		bcs	tasl0_draw_text_y_loop

		move.b	d1,-(sp)
		move	(sp)+,d1
		move.b	(a0)+,d1
		cmp	(a5)+,d1
		beq	tasl0_draw_text_mb_skip

		VTXT_MISS
		move	d1,(-2,a5)
		move	#NOT_A_CHAR,(a5)+	;E͂ǂ̕ƂvȂ悤ɂ

		moveq	#8,d2
		IOCS	_FNTADR
		movea.l	d0,a1

		tst.b	(WORK_OPT_R,a6)
		bne	tasl0_draw_text_mb_reverse

		move	a3,d0
		lsr	#1,d0
		bcs	tasl0_draw_text_mb_odd
;tasl0_draw_text_mb_even:
i:=0
		move	(a1)+,(a3)+
	.rept	16-1
		i:=i+128
		move	(a1)+,(i-2,a3)
	.endm
		dbra	d5,tasl0_draw_text_x_loop
		dbra	d7,tasl0_draw_text_y_loop
		bra	tasl0_draw_text_end

tasl0_draw_text_mb_odd:
i:=0
		move.b	(a1)+,(a3)+
		move.b	(a1)+,(a3)+
	.rept	16-1
		i:=i+128
		move.b	(a1)+,(i-2,a3)
		move.b	(a1)+,(i-1,a3)
	.endm
		dbra	d5,tasl0_draw_text_x_loop
		dbra	d7,tasl0_draw_text_y_loop
		bra	tasl0_draw_text_end

tasl0_draw_text_mb_reverse:
i:=0
		move.b	(a1)+,d0
		not.b	d0
		move.b	d0,(a3)+
		move.b	(a1)+,d0
		not.b	d0
		move.b	d0,(a3)+
	.rept	16-1
		i:=i+128
		move.b	(a1)+,d0
		not.b	d0
		move.b	d0,(i-2,a3)
		move.b	(a1)+,d0
		not.b	d0
		move.b	d0,(i-1,a3)
	.endm
		dbra	d5,tasl0_draw_text_x_loop
		dbra	d7,tasl0_draw_text_y_loop
		bra	tasl0_draw_text_end


		.end

* End of File --------------------------------- *
