		.title	TASL for X680x0 version 1.05 1997/03/25 Ԃq.

program:	.reg	'TASL for X680x0'
version:	.reg	'1.05'
date:		.reg	'1997/03/25'
author:		.reg	'Ԃq'


* Include File -------------------------------- *

		.include	tasl.h
		.include	eririn.mac
		.include	doscall.mac
		.include	iocscall.mac
		.include	fefunc.mac


* Fixed Number -------------------------------- *

	.ifdef	__CRLF__
CRLF:		.reg	CR,LF
	.else
CRLF:		.equ	LF
	.endif


* Offset Table -------------------------------- *

		.offset	0
SCH_TEXTNUM:	.ds.l	1
SCH_TIME:	.ds.l	1
sizeof_SCH:


* Macro --------------------------------------- *

STRCPY:		.macro	reg1,reg2
		.local	loop
loop:
		move.b	(reg1)+,(reg2)+
		bne	loop
		.endm


* Global Symbol ------------------------------- *

		.xref	tasl0
		.xref	tasl1
		.xref	tasl2


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even
start:
		bra.s	@f
		.dc.b	'#HUPAIR',0
@@:
		lea	(work,pc),a6

		lea	(16,a0),a0
		lea	(sizeof_WORK,a6),a1
		suba.l	a0,a1
		move.l	a1,-(sp)
		move.l	a0,-(sp)
		DOS	_SETBLOCK
		addq.l	#8,sp
		tst.l	d0
		bmi	setblock_error

		lea	(a6),a0			;bss clear
		moveq	#sizeof_WORK/4-1,d0
		moveq	#0,d1
@@:		move.l	d1,(a0)+
		dbra	d0,@b

	.if	COL_SYSTEM
		move.b	#COL_SYSTEM,(WORK_OPT_C,a6)
	.endif
	.if	MODE_DEFAULT
		move.b	#MODE_DEFAULT,(WORK_OPT_M,a6)
	.endif
	.if	OFFS_DEFAULT
		move.b	#OFFS_DEFAULT,(WORK_OPT_O,a6)
	.endif
	.if	DISP_DEFAULT
		move.b	#DISP_DEFAULT,(WORK_OPT_L,a6)
	.endif

		clr.l	-(sp)
		pea	(envname_tasl,pc)
		bsr	GetEnvPtr
		addq.l	#8,sp
		tst.l	d0
		bmi	env_end

		move.l	d0,-(sp)
		bra	arg_start
arg_end:
		tst.b	(WORK_PHASE,a6)		;$TASL $arg]t@C
		bne	read_from_stdin		;wȂW͂ǂݍ
env_end:
		addq.b	#1,(WORK_PHASE,a6)
		pea	(1,a2)
arg_start:
		bsr	GetArgCharInit
		addq.l	#4,sp
arg_loop:
		bsr	GetArgChar
		tst.l	d0
		bmi	arg_loop
		beq	arg_end
		cmpi.b	#'-',d0
		bne	arg_filename
arg_option:
		bsr	GetArgChar
		tst.b	d0
		beq	arg_no_more_option	;tasl - foo.tsl
arg_next_option:
		lea	(option_charlist,pc),a0
		lea	(option_jobtable-2,pc),a1
@@:
		addq.l	#2,a1
		move.b	(a0)+,d1
		beq	print_usage
		cmp.b	d0,d1
		bne	@b

		bsr	GetArgChar
		adda	(a1),a1
		jmp	(a1)
option_charlist:
		.dc.b	'?hcdfglmoprstx',0
		.even
option_jobtable:
		.dc	option_h-$
		.dc	option_h-$
		.dc	option_c-$
		.dc	option_d-$
		.dc	option_f-$
		.dc	option_g-$
		.dc	option_l-$
		.dc	option_m-$
		.dc	option_o-$
		.dc	option_p-$
		.dc	option_r-$
		.dc	option_s-$
		.dc	option_t-$
		.dc	option_x-$

* lw肷IvV

option_c:
		sf	(WORK_OPT_C,a6)
		tst.b	d0
		beq	arg_loop		;-c
		bsr	is_number_or_pm
		bne	arg_next_option		;-cf

		bsr	get_arg_num		;-c<n>
		bmi	color_num_error
		moveq	#COLOR_MAX,d2
		cmp.l	d2,d1
		bhi	color_num_error

		st	(WORK_OPT_C,a6)
		add	d1,d1
		move	(color2palette_table,pc,d1.w),(WORK_COLOR,a6)

		cmpi.b	#',',d0
		bne	option_num_next
		bsr	GetArgChar
		bsr	is_number_or_pm
		bne	color_num_error

		bsr	get_arg_num		;-c<n>,<n2>
		bmi	color_num_error
*		moveq	#COLOR_MAX,d2
		cmp.l	d2,d1
		bhi	color_num_error

		neg.b	(WORK_OPT_C,a6)
		add	d1,d1
		move	(color2palette_table,pc,d1.w),(WORK_COLOR_BG,a6)
		bra	option_num_next

color2palette_table:	*GGGGG_RRRRR_BBBBB_I
		.dc	%00000_00000_00000_1	;black
		.dc	%00000_00000_11111_0	;blue
		.dc	%00000_11111_00000_0	;red
		.dc	%00000_11111_11111_0	;purple
		.dc	%11111_00000_00000_0	;green
		.dc	%11111_00000_11111_0	;light blue
		.dc	%11111_11111_00000_0	;yellow
		.dc	%11111_11111_11111_0	;white

option_l:
		move.b	#DISP_24KHZ,(WORK_OPT_L,a6)
		tst.b	d0
		beq	arg_loop		;-l
		bsr	is_number_or_pm
		bne	arg_next_option		;-lf

		bsr	get_arg_num		;-l<n>
		bmi	display_num_error
		move.b	d1,(WORK_OPT_L,a6)
		subq.l	#DISP_MAX,d1
		bhi	display_num_error
		bra	option_num_next
option_m:
		move.b	#MODE_DEFAULT,(WORK_OPT_M,a6)
		tst.b	d0
		beq	arg_loop		;-m
		bsr	is_number_or_pm
		bne	arg_next_option		;-mf

		bsr	get_arg_num		;-m<n>
		bmi	mode_num_error
		moveq	#MODE_MAX,d2
		cmp.l	d2,d1
		bhi	mode_num_error
		move.b	d1,(WORK_OPT_M,a6)
		bra	option_num_next
option_p:
		sf	(WORK_OPT_C,a6)
		tst.b	d0
		beq	arg_loop		;-p
		bsr	is_number_or_pm
		bne	arg_next_option		;-pf

		bsr	get_arg_num		;-p<n>
		bmi	palette_num_error
		moveq	#0,d2
		not	d2			;d2.l=$ffff
		cmp.l	d2,d1
		bhi	palette_num_error

		st	(WORK_OPT_C,a6)
		move	d1,(WORK_COLOR,a6)

		cmpi.b	#',',d0
		bne	option_num_next
		bsr	GetArgChar
		bsr	is_number_or_pm
		bne	palette_num_error

		bsr	get_arg_num		;-p<n>,<n2>
		bmi	palette_num_error
		cmp.l	d2,d1
		bhi	palette_num_error

		neg.b	(WORK_OPT_C,a6)
		move	d1,(WORK_COLOR_BG,a6)
		bra	option_num_next
option_s:
		sf	(WORK_OPT_S,a6)
		bsr	is_number_or_pm
		bne	option_num_next		;-s / -sf

		bsr	get_arg_num		;-s<n>
		bmi	slow_num_error
		tst.l	d1
		bmi	slow_num_error

		move.l	d1,(WORK_SLOW_CNT,a6)
		subq.l	#1,d1
		sne	(WORK_OPT_S,a6)		;-s1Ȃ
		bra	option_num_next
option_num_next:
		tst.b	d0
		beq	arg_loop		;-s  (d0=NUL)
		bra	arg_next_option		;-sf (d0='f')

* +/-w肷IvV

option_d:
		lea	(WORK_OPT_D,a6),a0
		bra	set_plus_minus_option
option_f:
		lea	(WORK_OPT_F,a6),a0
		bra	set_plus_minus_option
option_g:
		lea	(WORK_OPT_G,a6),a0
		bra	set_plus_minus_option
option_r:
		lea	(WORK_OPT_R,a6),a0
		bra	set_plus_minus_option
option_t:
		lea	(WORK_OPT_T,a6),a0
		bra	set_plus_minus_option
option_x:
		lea	(WORK_OPT_X,a6),a0
		bra	set_plus_minus_option
set_plus_minus_option:
		tst.b	d0
		beq	set_pm_option_no_arg
		cmpi.b	#'-',d0
		beq	set_pm_option_minus
		cmpi.b	#'+',d0
		beq	set_pm_option_plus

		st	(a0)			;-fg
		bra	arg_next_option
set_pm_option_minus:
		st	(a0)			;-f-
		bra	arg_loop
set_pm_option_plus:
		sf	(a0)			;-f+
		bra	arg_loop
set_pm_option_no_arg:
		not.b	(a0)			;-f
		bra	arg_loop

option_o:
		tst.b	d0
		beq	option_o_no_arg
		cmpi.b	#'c',d0
		beq	option_oc
		bsr	is_number_or_pm
		beq	option_o_xy

*		move.b	#OFFS_DATA_XY,(WORK_OPT_O,a6)
		st	(WORK_OPT_O,a6)		;-of	(f[^̍W)
		bra	arg_next_option
option_o_no_arg:
*		move.b	#OFFS_DATA_XY,(WORK_OPT_O,a6)
		st	(WORK_OPT_O,a6)		;-o	(f[^̍W)
		bra	arg_loop
option_oc:
*		move.b	#OFFS_CENTER,(WORK_OPT_O,a6)
		clr.b	(WORK_OPT_O,a6)		;-oc	(ʒ)
		bra	arg_loop
option_o_xy:
		move.b	#OFFS_OPT_XY,(WORK_OPT_O,a6)
		bsr	get_arg_num		;-o<x>,<y>
		bmi	offset_num_error	;	(ʒuw)
		move.l	d1,(WORK_OPT_OX,a6)

		cmpi.b	#',',d0
		bne	offset_num_error

		bsr	GetArgChar
		bsr	is_number_or_pm
		bne	offset_num_error

		bsr	get_arg_num
		bmi	offset_num_error
		move.l	d1,(WORK_OPT_OY,a6)
		bra	option_num_next


* IvV͉ ------------------------ *

* '+','-'Ȃccr Z=1
is_number_or_pm:
		cmpi.b	#'-',d0
		beq	@f
		cmpi.b	#'+',d0
		beq	@f

* Ȃccr Z=1
is_number:
		cmpi.b	#'0',d0
		bcs	@f
		cmpi.b	#'9',d0
		bhi	@f
		cmp.b	d0,d0
@@:		rts

* 琔l
* in	d0.l	ŏ̐or('+'or'-')
* out	d0.l	łȂȂ̕
*	d1.l	l(signed long)
*	ccr Z	1:ok 0:error(overflow)
*	ccr N	0:ok 1:error(overflow)

get_arg_num:
		PUSH	d2-d3
		moveq	#-1,d3
		cmpi.b	#'+',d0
		beq	get_arg_num_plus
		cmpi.b	#'-',d0
		bne	get_arg_num_nosign
;get_arg_num_minus:
		bsr	GetArgChar
		bsr	is_number
		bne	get_arg_num_end

		bsr	get_arg_num_sub
		neg.l	d1
		bra	get_arg_num_end
get_arg_num_plus:
		bsr	GetArgChar
		bsr	is_number
		bne	get_arg_num_end
get_arg_num_nosign:
		bsr	get_arg_num_sub
get_arg_num_end:
		tst.b	d3
		POP	d2-d3
		rts

get_arg_num_sub:
		moveq	#0,d3			;overflow flag
		moveq	#$f,d1
		and.b	d0,d1
		bra	get_arg_num_sub_start
get_arg_num_sub_loop:
		moveq	#$f,d2
		and.b	d0,d2

		moveq	#10,d0
		FPACK	__LMUL			;d0*=d1
		scs	d1
		or.b	d1,d3			;set

		move.l	d0,d1
		add.l	d2,d1
		smi	d0
		or.b	d0,d3			;set
get_arg_num_sub_start:
		bsr	GetArgChar
		bsr	is_number
		beq	get_arg_num_sub_loop
;get_arg_num_sub_end:
		tst.b	d3
		rts

* IvV֌WI

arg_no_more_option:
		bsr	GetArgChar
		tst.l	d0
		bmi	arg_no_more_option
		beq	print_usage		;tasl -
arg_filename:
		lea	(WORK_FILENAME,a6),a0
		moveq	#FILENAME_MAX-1,d1
		bra	@f
arg_filename_loop:
		bsr	GetArgChar
@@:		move.b	d0,(a0)+
		dbeq	d1,arg_filename_loop
		bne	filename_error
read_from_stdin:
		lea	(tasl0,pc),a0		;[hƂ̃e[uAhXݒ
		cmpi.b	#1,(WORK_OPT_M,a6)
		bcs	@f
		lea	(tasl1,pc),a0
		beq	@f
		lea	(tasl2,pc),a0
@@:		move.l	a0,(WORK_MODEPTR,a6)

		tst.b	(WORK_OPT_L,a6)
		beq	@f
		addq.l	#TASL_X_SIZE_L,a0
@@:		moveq	#0,d0
		move	(a0)+,d0		;TASL_X_SIZE(_L)
		move.l	d0,(WORK_MAX_X,a6)
		move	(a0)+,d0		;TASL_Y_SIZE(_L)
		move.l	d0,(WORK_MAX_Y,a6)

		movea.l	(WORK_MODEPTR,a6),a1	;[hƂ̃obt@m
		move.l	(TASL_MEM_SIZE,a1),-(sp)
		DOS	_MALLOC
		move.l	d0,(sp)+
		bmi	malloc_error

		move.l	d0,(WORK_BUFPTR,a6)

		lea	(WORK_FILENAME,a6),a0
		moveq	#STDIN,d7
		tst.b	(a0)
		beq	file_open_ok		;t@Cȗ͕W͂

		clr	-(sp)
		pea	(a0)
		DOS	_OPEN
		addq.l	#6,sp
		move.l	d0,d7
		bpl	file_open_ok

		lea	(a0),a1
@@:		tst.b	(a1)+
		bne	@b
		subq.l	#1,a1
		move.l	a1,d0
		sub.l	a0,d0
		moveq	#FILENAME_MAX-4,d1	;4=strlen(".tsl")
		cmp.l	d1,d0
		bcc	file_open_error

		lea	(complete_ext_tsl,pc),a2
		STRCPY	a2,a1
		clr	-(sp)
		pea	(a0)
		DOS	_OPEN
		addq.l	#6,sp
		move.l	d0,d7
		bmi	file_open_error
file_open_ok:
		move	#SEEK_END,-(sp)
		clr.l	-(sp)
		move	d7,-(sp)
		DOS	_SEEK
		move.l	d0,d1
		clr	(6,sp)
		DOS	_SEEK
		addq.l	#8,sp
		or.l	d1,d0
		bmi	file_seek_error

		tst.b	(WORK_FILENAME,a6)
		bne	@f
		tst.l	d1
		beq	print_usage		;蔲stdin dup`FbN
@@:
		move.l	d1,(WORK_FILELEN,a6)
		move.l	d1,(WORK_FILECNT,a6)

		move.l	d1,-(sp)		;.tslǂݍ݃obt@m
		DOS	_MALLOC
		move.l	d0,(sp)+
		bmi	malloc_error

		move.l	d0,(WORK_FILEBUF,a6)
		move.l	d0,(WORK_FILEPTR,a6)

		move.l	d1,-(sp)
		move.l	d0,-(sp)
		move	d7,-(sp)
		DOS	_READ
		addq.l	#10-4,sp
		cmp.l	(sp)+,d0
		bne	file_read_error

		bsr	close_file
	.if	0
		bmi	file_close_error
	.endif
		movea.l	(WORK_MODEPTR,a6),a1	;[hƂ̃obt@
		adda	(TASL_INIT_BUF,a1),a1	;(zeLXgNA/tHgǂݍ)
		jsr	(a1)

		bsr	get_fncmode
		bsr	get_graphic_disp
		bsr	save_text_palette

		pea	(abort_entry,pc)
		move	#_CTRLVC,-(sp)
		DOS	_INTVCS
		addq.l	#6,sp

		bsr	clear_fnckey
		bsr	graphic_off
		bsr	change_text_palette
		bsr	set_vdisp_int
		bsr	tasl_play
abort_job:
		move	d0,-(sp)
		move.l	(WORK_BUFPTR,a6),-(sp)
		DOS	_MFREE
		addq.l	#4,sp
		bsr	restore_vdisp_int
		bsr	restore_text_palette
		bsr	graphic_on
		bsr	restore_fnckey
		moveq	#31,d1
		IOCS	_B_DOWN

		tst	(sp)
		bne	@f
		bsr	print_overtime
@@:
		DOS	_EXIT2

abort_entry:
		lea	(work,pc),a6
		moveq	#2,d0
		bra	abort_job


* 荞ݐݒ/ --------------------------- *

set_vdisp_int:
		PUSH	a0-a2
		TO_SUPER

		move.l	(VDISP_VEC*4),(WORK_VDISP_VEC,a6)
		lea	(vdisp_int_entry,pc),a0
		move.l	a0,(VDISP_VEC*4)

		lea	(MFP_AER),a0
		lea	(MFP_IERB-MFP_AER,a0),a1
		lea	(MFP_IMRB-MFP_AER,a0),a2
		move.b	(a0),(WORK_MFP_AER,a6)
		bclr	#4,(a0)			;Ö
		move.b	(a1),(WORK_MFP_IERB,a6)
		move.b	(a2),(WORK_MFP_IMRB,a6)
		moveq	#6,d0
		bset	d0,(a1)
		bset	d0,(a2)

		TO_USER
		POP	a0-a2
		rts

restore_vdisp_int:
		tst.l	(WORK_VDISP_VEC,a6)
		beq	restore_vdisp_int_skip

		PUSH	a0-a2
		TO_SUPER

		lea	(MFP_AER),a0
		lea	(MFP_IERB-MFP_AER,a0),a1
		lea	(MFP_IMRB-MFP_AER,a0),a2
		moveq	#4,d0
		btst	d0,(WORK_MFP_AER,a6)
		beq	@f
		bset	d0,(a0)
@@:		moveq	#6,d0
		btst	d0,(WORK_MFP_IERB,a6)
		bne	@f
		bclr	d0,(a1)
@@:		btst	d0,(WORK_MFP_IMRB,a6)
		bne	@f
		bclr	d0,(a2)
@@:
		move.l	(WORK_VDISP_VEC,a6),(VDISP_VEC*4)
		clr.l	(WORK_VDISP_VEC,a6)

		TO_USER
		POP	a0-a2
restore_vdisp_int_skip:
		rts


* 񐔂̕\ -------------------------- *

print_overtime:
		moveq	#0,d0
		move	(WORK_OVERTIME,a6),d0
		beq	print_overtime_end

		lea	(-128,sp),sp
		lea	(sp),a0
		lea	(overtime_mes,pc),a1
		STRCPY	a1,a0
		subq.l	#1,a0
		FPACK	__LTOS
		lea	(crlf_mes,pc),a1
		STRCPY	a1,a0

		move	#STDERR,-(sp)
		pea	(2,sp)
		DOS	_FPUTS
		lea	(128+6,sp),sp
print_overtime_end:
		rts


* gp@\ ---------------------------------- *

option_h:
		bsr	print_usage_sub
		DOS	_EXIT

print_usage:
		bsr	print_usage_sub
		move	#1,-(sp)
		DOS	_EXIT2

print_usage_sub:
		pea	(title_mes,pc)
		DOS	_PRINT
		pea	(usage_mes,pc)
		DOS	_PRINT
		addq.l	#8,sp
		rts


* G[I ---------------------------------- *

close_file:
		tst.b	(WORK_FILENAME,a6)
		beq	@f
		move	d7,-(sp)
		DOS	_CLOSE
		addq.l	#2,sp
		tst.l	d0
@@:		rts

file_seek_error:
		bsr	close_file
		lea	(seek_error_mes,pc),a0
		bra	error_exit
file_read_error:
		bsr	close_file
		lea	(read_error_mes,pc),a0
		bra	error_exit
malloc_error:
		bsr	close_file
		lea	(malloc_error_mes,pc),a0
		bra	error_exit

setblock_error:
		lea	(setblock_error_mes,pc),a0
		bra	error_exit
filename_error:
		lea	(filename_error_mes,pc),a0
		bra	error_exit
file_open_error:
		lea	(open_error_mes,pc),a0
		bra	error_exit
	.if	0
file_close_error:
		lea	(close_error_mes,pc),a0
		bra	error_exit
	.endif

color_num_error:
		lea	(color_error_mes,pc),a0
		bra	error_exit
display_num_error:
		lea	(display_error_mes,pc),a0
		bra	error_exit
mode_num_error:
		lea	(mode_error_mes,pc),a0
		bra	error_exit
palette_num_error:
		lea	(palette_error_mes,pc),a0
		bra	error_exit
slow_num_error:
		lea	(slow_error_mes,pc),a0
		bra	error_exit
offset_num_error:
		lea	(offset_error_mes,pc),a0
		bra	error_exit

error_exit:
		bsr	print_error_message
		move	#1,-(sp)
		DOS	_EXIT2

print_error_message:
		move	#STDERR,-(sp)
		pea	(tasl_mes,pc)
		DOS	_FPUTS
		move.l	a0,(sp)
		DOS	_FPUTS
		addq.l	#6,sp
		rts


* \FύX ---------------------------------- *

save_text_palette:
		PUSH	d1-d2
		moveq	#BG_COLOR,d1		;wiF̕ۑ
		moveq	#-1,d2
		IOCS	_TPALET
		move	d0,(WORK_TPAL0,a6)

		moveq	#DRAW_COLOR,d1		;F̕ۑ
*		moveq	#-1,d2
		IOCS	_TPALET
		move	d0,(WORK_TPAL3,a6)
		POP	d1-d2
		rts

change_text_palette:
		tst.b	(WORK_OPT_C,a6)
		beq	change_text_palette_skip
		PUSH	d1-d2
		bmi	@f

		moveq	#BG_COLOR,d1		;wiF̕ύX
		moveq	#0,d2
		move	(WORK_COLOR_BG,a6),d2
		IOCS	_TPALET
@@:
		moveq	#DRAW_COLOR,d1		;F̕ύX
		moveq	#0,d2
		move	(WORK_COLOR,a6),d2
		IOCS	_TPALET
		POP	d1-d2
change_text_palette_skip:
		rts

restore_text_palette:
		tst.b	(WORK_OPT_C,a6)
		beq	restore_text_palette_skip
		PUSH	d1-d2
		bmi	@f

		moveq	#BG_COLOR,d1		;wiF̕A
		moveq	#0,d2
		move	(WORK_TPAL0,a6),d2
		IOCS	_TPALET
@@:
		moveq	#DRAW_COLOR,d1		;F̕A
		moveq	#0,d2
		move	(WORK_TPAL3,a6),d2
		IOCS	_TPALET
		POP	d1-d2
restore_text_palette_skip:
		rts


* OtBbN On/Off ------------------------- *

get_graphic_disp:
		move.l	d1,-(sp)
		moveq	#-1,d1
		IOCS	$93			;move ($e82600),d0
		move	d0,(WORK_VC_R2,a6)
		move.l	(sp)+,d1
		rts

graphic_off:
		tst.b	(WORK_OPT_G,a6)
		beq	graphic_off_skip

		move.l	d1,-(sp)
		moveq	#.not.$001f,d1
		and	(WORK_VC_R2,a6),d1
		IOCS	$93			;move d1,($e82600)
		move.l	(sp)+,d1
graphic_off_skip:
		rts

graphic_on:
		tst.b	(WORK_OPT_G,a6)
		beq	graphic_on_skip

		move.l	d1,-(sp)
		move	(WORK_VC_R2,a6),d1
		IOCS	$93			;move d1,($e82600)
		move.l	(sp)+,d1
graphic_on_skip:
		rts


* t@NVL[s -------------------- *

get_fncmode:
		move.l	#14<<16+$ffff,-(sp)
		DOS	_CONCTRL
		addq.l	#4,sp
		move	d0,(WORK_FNCMODE,a6)
		sf	(WORK_FNCFLAG,a6)
		rts

clear_fnckey:
		cmpi	#2,(WORK_FNCMODE,a6)
		bcc	clear_fnckey_skip
		tas	(WORK_FNCFLAG,a6)
		bne	clear_fnckey_skip

		move.l	#14<<16+2,-(sp)
		DOS	_CONCTRL
		addq.l	#4,sp
clear_fnckey_skip:
		rts

restore_fnckey:
		tst.b	(WORK_FNCFLAG,a6)
		beq	restore_fnckey_skip
		tst.b	(WORK_OPT_F,a6)
		bne	restore_fnckey_skip

		move	(WORK_FNCMODE,a6),-(sp)
		move	#14,-(sp)
		DOS	_CONCTRL
		addq.l	#4,sp
		sf	(WORK_FNCFLAG,a6)
restore_fnckey_skip:
		rts


* ɓǂݍ.TSLt@C߂ĕ\.
* out	d0.w	G[R[h

tasl_play:
		bsr	skip_blank_line
		bmi	tasl_play_header_error
;o[Wԍ
		moveq	#4-1,d2			;4=strlen("1.00")
@@:		bsr	getchar
		bmi	getnum_error
		lsl.l	#8,d1
		move.b	d0,d1
		dbra	d2,@b
		cmpi.l	#DATAVER_MIN,d1
		bcs	tasl_play_version_error
		cmpi.l	#DATAVER_MAX,d1
		bhi	tasl_play_version_error
		bsr	skip_after_blank
		bmi	tasl_play_version_error

		bsr	skip_blank_line
		bmi	tasl_play_header_error
;eLXg
		bsr	getnum
		bmi	tasl_play_header_error
		move.l	d0,(WORK_TEXTNUM,a6)
		bsr	skip_after_blank
		bmi	tasl_play_header_error

		bsr	skip_blank_line
		bmi	tasl_play_header_error
;eLXg
		bsr	getnum
		bmi	tasl_play_header_error
		move.l	d0,(WORK_SIZE_X,a6)
		beq	tasl_play_header_error
		bsr	skip_after_blank
		bmi	tasl_play_header_error

		bsr	skip_blank_line
		bmi	tasl_play_header_error
;eLXgs
		bsr	getnum
		bmi	tasl_play_header_error
		move.l	d0,(WORK_SIZE_Y,a6)
		beq	tasl_play_header_error
		bsr	skip_after_blank
		bmi	tasl_play_header_error

		bsr	skip_blank_line
		bmi	tasl_play_header_error
;\ʒu(X)
		bsr	getchar
		bmi	tasl_play_header_error
		cmpi	#'-',d0
		beq	@f

		bsr	putbackchar
		bsr	getnum
		bmi	tasl_play_header_error
		bra	1f
@@:
		bsr	getnum
		bmi	tasl_play_header_error
		neg.l	d0
1:		move.l	d0,(WORK_DISP_X,a6)
		bsr	skip_after_blank
		bmi	tasl_play_header_error

		bsr	skip_blank_line
		bmi	tasl_play_header_error
;\ʒu(Y)
		bsr	getchar
		bmi	tasl_play_header_error
		cmpi	#'-',d0
		beq	@f

		bsr	putbackchar
		bsr	getnum
		bmi	tasl_play_header_error
		bra	1f
@@:
		bsr	getnum
		bmi	tasl_play_header_error
		neg.l	d0
1:		move.l	d0,(WORK_DISP_Y,a6)
		bsr	skip_after_blank
		bmi	tasl_play_header_error

		bsr	skip_blank_line
		bmi	tasl_play_header_error

*		clr.l	(WORK_SKIP_X,a6)
*		clr.l	(WORK_SKIP_Y,a6)

		tst.b	(WORK_OPT_O,a6)
		beq	tasl_play_centering	;$00=-oc
		bmi	tasl_play_clipping	;$ff=-o
;wWɕ\
;tasl_play_xy_set:
		move.l	(WORK_OPT_OX,a6),(WORK_DISP_X,a6)
		move.l	(WORK_OPT_OY,a6),(WORK_DISP_Y,a6)
		bra	tasl_play_clipping

;\ʒuZ^O
tasl_play_centering:
		move.l	(WORK_MAX_X,a6),d0
		sub.l	(WORK_SIZE_X,a6),d0
		asr.l	#1,d0
		move.l	d0,(WORK_DISP_X,a6)

		move.l	(WORK_MAX_Y,a6),d0
		sub.l	(WORK_SIZE_Y,a6),d0
		asr.l	#1,d0
		move.l	d0,(WORK_DISP_Y,a6)
tasl_play_clipping:
		move.l	(WORK_DISP_X,a6),d0
		bpl	@f
		neg.l	d0
		clr.l	(WORK_DISP_X,a6)
		move.l	d0,(WORK_SKIP_X,a6)
		sub.l	d0,(WORK_SIZE_X,a6)
		ble	tasl_play_clipping_error	;ɂ͂ݏoʂ
@@:
		move.l	(WORK_MAX_X,a6),d0
		sub.l	(WORK_DISP_X,a6),d0
		ble	tasl_play_clipping_error	;JnʒuE[͂ݏoĂ
		cmp.l	(WORK_SIZE_X,a6),d0
		bcc	@f
		move.l	d0,(WORK_SIZE_X,a6)
@@:
		move.l	(WORK_DISP_Y,a6),d0
		bpl	@f
		neg.l	d0
		clr.l	(WORK_DISP_Y,a6)
		move.l	d0,(WORK_SKIP_Y,a6)
		sub.l	d0,(WORK_SIZE_Y,a6)
		ble	tasl_play_clipping_error	;ɂ͂ݏoʂ
@@:
		move.l	(WORK_MAX_Y,a6),d0
		sub.l	(WORK_DISP_Y,a6),d0
		ble	tasl_play_clipping_error	;Jnʒu[͂ݏoĂ
		cmp.l	(WORK_SIZE_Y,a6),d0
		bcc	@f
		move.l	d0,(WORK_SIZE_Y,a6)
@@:
;^Cg
		bsr	tasl_play_print_title
		bmi	tasl_play_title_error

		bsr	skip_blank_line
		bmi	tasl_play_header_error

;͗pobt@m
		move.l	#$00ffffff,-(sp)
		DOS	_MALLOC
		and.l	(sp)+,d0
		cmpi.l	#1024,d0
		bcs	tasl_play_malloc_error

		move.l	d0,d7
		move.l	d0,-(sp)
		DOS	_MALLOC
		move.l	d0,(sp)+
		bmi	tasl_play_malloc_error

		move.l	d7,(WORK_MEMSIZE,a6)
		move.l	d0,(WORK_MEMPTR,a6)
		movea.l	d0,a5

;XPW[
		bsr	tasl_play_analyze_sch
		bmi	tasl_play_sch_error

;eLXgʂւ̃|C^z
		bsr	tasl_play_analyze_text
		bmi	tasl_play_text_error

;͗pobt@Kvȗʂɒ(ӖȂ...
	.if	0
		move.l	(WORK_MEMPTR,a6),d0
		suba.l	d0,a5
		move.l	a5,-(sp)
		move.l	d0,-(sp)
		DOS	_SETBLOCK
		addq.l	#8,sp
		tst.l	d0
		bmi	tasl_play_setblock_error
	.endif

;\C
		bsr	tasl_play_main
		bmi	tasl_play_play_error

;͗pobt@
		bsr	mfree_analyze_buffer
	.if	0
		bmi	tasl_play_mfree_error
	.endif
		moveq	#0,d0
		rts


* f[^͒̃G[ -------------------- *

mfree_analyze_buffer:
		move.l	(WORK_MEMPTR,a6),-(sp)
		DOS	_MFREE
		move.l	d0,(sp)+
		rts

tasl_play_play_error:
		bsr	mfree_analyze_buffer
		lea	(play_error_mes,pc),a0
		bra	tasl_play_error_end
tasl_play_sch_error:
		bsr	mfree_analyze_buffer
		lea	(sch_error_mes,pc),a0
		bra	tasl_play_error_end
tasl_play_text_error:
		bsr	mfree_analyze_buffer
		lea	(text_error_mes,pc),a0
		bra	tasl_play_error_end
	.if	0
tasl_play_setblock_error:
		bsr	mfree_analyze_buffer
		lea	(setblock_error_mes,pc),a0
		bra	tasl_play_error_end
	.endif

tasl_play_version_error:
		lea	(version_error_mes,pc),a0
		bra	tasl_play_error_end
tasl_play_header_error:
		lea	(header_error_mes,pc),a0
		bra	tasl_play_error_end
tasl_play_clipping_error:
		lea	(clipping_error_mes,pc),a0
		bra	tasl_play_error_end
tasl_play_title_error:
		lea	(title_error_mes,pc),a0
		bra	tasl_play_error_end
tasl_play_malloc_error:
		lea	(malloc_error_mes,pc),a0
		bra	tasl_play_error_end
	.if	0
tasl_play_mfree_error:
		lea	(mfree_error_mes,pc),a0
		bra	tasl_play_error_end
	.endif

tasl_play_error_end:
		bsr	print_error_message
		moveq	#1,d0
		rts


* eLXgʂ̃AhX.
* in	d7.l	obt@coCg
*	a5.l	obt@݃|C^

tasl_play_analyze_text:
		move.l	d1,-(sp)
		move.l	a5,(WORK_TEXTPTR,a6)
		move.l	(WORK_TEXTNUM,a6),d0
		addq.l	#1,d0
		lsl.l	#2,d0
		sub.l	d0,d7
		bcs	tasl_play_analyze_text_buferr

		clr.l	(a5)+			;擪(text[0])̓_~[
		move.l	(WORK_TEXTNUM,a6),d1
tasl_play_analyze_text_loop:
		move.l	(WORK_FILEPTR,a6),(a5)+
@@:
		bsr	search_lf
		bmi	tasl_play_analyze_text_error
		bsr	getchar
		bmi	tasl_play_analyze_text_error
		cmpi	#FF,d0
		bne	@b

		bsr	search_lf		;^ĽɂĂs
		bmi	tasl_play_analyze_text_error
		subq.l	#1,d1
		bne	tasl_play_analyze_text_loop

		move.l	(sp)+,d1
		moveq	#0,d0
		rts
tasl_play_analyze_text_error:
tasl_play_analyze_text_buferr:
		move.l	(sp)+,d1
		moveq	#-1,d0
		rts

* XPW[
* in	d7.l	obt@coCg
*	a5.l	obt@݃|C^

tasl_play_analyze_sch:
		move.l	a5,(WORK_SCHPTR,a6)
		clr.l	(WORK_SCHNUM,a6)

		bsr	getchar
		bmi	tasl_play_analyze_sch_error
		cmpi	#FF,d0
		beq	tasl_play_analyze_sch_error
tasl_play_analyze_sch_loop:
		bsr	is_d0_tab_or_space	;s͋
		bne	tasl_play_analyze_sch_error

		bsr	skip_tab_space
		bmi	tasl_play_analyze_sch_error
		bsr	getnum			;textԍ(0Ȃcommand)
		bmi	tasl_play_analyze_sch_error
		move.l	d0,d1
		bsr	skip_tab_space
		bmi	tasl_play_analyze_sch_error
		bsr	getnum			;(command̏ꍇ͋@\)
		bmi	tasl_play_analyze_sch_error

		subq.l	#sizeof_SCH,d7
		bcs	tasl_play_analyze_sch_buferr

		move.l	d1,(SCH_TEXTNUM,a5)
		beq	@f			;R}ḧ͂̂܂
		move.l	(WORK_SLOW_CNT,a6),d1
		beq	@f			;-sw
		FPACK	__UMUL
		bcc	@f
		moveq	#-1,d0
@@:
		move.l	d0,(SCH_TIME,a5)
		addq.l	#sizeof_SCH,a5

		bsr	skip_blank_line
		bmi	tasl_play_analyze_sch_error

		bsr	getchar
		bmi	tasl_play_analyze_sch_error
		cmpi	#FF,d0
		bne	tasl_play_analyze_sch_loop

		bsr	search_lf
		bmi	tasl_play_analyze_sch_error

		move.l	a5,(WORK_SCHEND,a6)
		moveq	#0,d0
		rts
tasl_play_analyze_sch_error:
tasl_play_analyze_sch_buferr:
		moveq	#-1,d0
		rts

skip_tab_space:
		bsr	getchar
		bmi	skip_tab_space_error
		bsr	is_d0_tab_or_space
		beq	skip_tab_space

		bsr	putbackchar
		moveq	#0,d0
		rts
skip_tab_space_error:
		moveq	#-1,d0
		rts

* TASLf[^̃^Cg\.
* out	d0.l	G[R[h

tasl_play_print_title:
		bsr	init_screen
		bsr	init_textside_no_sync
		bra	@f
tasl_play_print_title_lf:
		tst.b	(WORK_OPT_T,a6)
		bne	@f

		move	d0,-(sp)
		DOS	_PUTCHAR
		addq.l	#2,sp
@@:
		bsr	getchar
		bmi	tasl_play_print_title_error
		cmpi	#FF,d0			;^L͍ŝݔF
		beq	tasl_play_print_title_end
tasl_play_print_title_loop:
	.ifndef	__CRLF__
		cmpi	#CR,d0			;CR͖
		beq	tasl_play_print_title_next
	.endif
		cmpi	#LF,d0
		beq	tasl_play_print_title_lf

		tst.b	(WORK_OPT_T,a6)
		bne	tasl_play_print_title_next

		move	d0,-(sp)
		bpl	@f
		lsr	#8,d0			;ʃoCg
		move	d0,-(sp)
		DOS	_PUTCHAR
		addq.l	#2,sp
		clr.b	(sp)			;ʃoCg
@@:		DOS	_PUTCHAR
		addq.l	#2,sp
tasl_play_print_title_next:
		bsr	getchar
		bmi	tasl_play_print_title_error
		bra	tasl_play_print_title_loop
tasl_play_print_title_end:
		bsr	search_lf
		bmi	tasl_play_print_title_error

		moveq	#0,d0
		rts
tasl_play_print_title_error:
		moveq	#-1,d0
		rts

* R\[.

init_screen:
		PUSH	d1-d2/a1
		tas	(WORK_SCRFLAG,a6)
		bne	init_screen_clear

		tst.b	(WORK_OPT_L,a6)
		bne	@f
		lea	(CRTC_R20l),a1
		IOCS	_B_BPEEK
		cmpi.b	#$16,d0
		bne	init_screen_conctrl_force
@@:
		move.l	#16<<16+$ffff,-(sp)
		DOS	_CONCTRL
		addq.l	#4,sp
		subq.l	#1,d0
		bls	init_screen_conctrl_skip
init_screen_conctrl_force:
		move.l	#16<<16+0,-(sp)		;768x512,graphic off
		DOS	_CONCTRL
		addq.l	#4,sp
init_screen_conctrl_skip:
		tst.b	(WORK_OPT_L,a6)
		beq	init_screen_31khz

		bsr	set_crt_640x400
		move.l	#0<<16+0,d1
		move.l	#(640/8-1)<<16+(400/16-1-1),d2
		IOCS	_B_CONSOL
		bra	init_screen_clear
init_screen_31khz:
		move.l	#0<<16+31,-(sp)		;XN[͈͂
		move	#15,-(sp)
		DOS	_CONCTRL
		addq.l	#6,sp
init_screen_clear:
		move.l	#10<<16+2,-(sp)		;ʑS̏
		DOS	_CONCTRL
		addq.l	#4,sp
		POP	d1-d2/a1
		rts

* [PC-98ʃ[hݒ.

set_crt_640x400:
		TO_SUPER
		PUSH	a0-a1
		lea	(crtc_640x400_data,pc),a0
		lea	(CRTC_R00),a1
		moveq	#8-1,d0
@@:
		move	(a0)+,(a1)+
		dbra	d0,@b
		move.b	#$15,(CRTC_R20l)
		POP	a0-a1
		TO_USER
		rts

* eLXgW.

init_textside:
		TO_SUPER
@@:		btst	#4,(MFP_GPIP)
		beq	@b			;\Ԃ܂őҋ@
@@:		btst	#4,(MFP_GPIP)
		bne	@b			;AV
		TO_USER
init_textside_no_sync:
		PUSH	d1-d3
		moveq	#8,d1
		moveq	#0,d2
		moveq	#0,d3
		IOCS	_SCROLL
		move.b	d2,(WORK_TEXTSIDE,a6)
		POP	d1-d3
		rts

* s̎cj.
* out	d0.l	G[R[h

search_lf:
		bsr	getchar
		bmi	search_lf_error
		cmpi	#LF,d0
		bne	search_lf

		moveq	#0,d0
		rts
search_lf_error:
		moveq	#-1,d0
		rts


* 1AorsA܂́AXy[Xor^u{'#'ł邩ׁA
* łꍇ͂̍s̎cSĔj.
* out	d0.l	G[R[h

skip_after_blank:
		bsr	getchar
		bmi	skip_after_blank_error
		cmpi	#CR,d0
		beq	skip_after_blank_search_lf
		cmpi	#LF,d0
		beq	skip_after_blank_end

		bsr	is_d0_tab_or_space
		bne	skip_after_blank_error
skip_after_blank_skip_blank:
		bsr	getchar
		bmi	skip_after_blank_error
		bsr	is_d0_tab_or_space
		beq	skip_after_blank_skip_blank
		cmpi	#CR,d0
		beq	skip_after_blank_search_lf
		cmpi	#LF,d0
		beq	skip_after_blank_end
		cmpi	#'#',d0
		bne	skip_after_blank_error
skip_after_blank_search_lf:
		bsr	getchar
		bmi	skip_after_blank_error
		cmpi	#LF,d0
		bne	skip_after_blank_search_lf
skip_after_blank_end:
		moveq	#0,d0
		rts
skip_after_blank_error:
		moveq	#-1,d0
		rts

is_d0_tab_or_space:
		cmpi	#TAB,d0
		beq	@f
		cmpi	#SPACE,d0
@@:		rts

* l.
* out	d0.l	l(-1ȂG[)

getnum:
		move.l	d1,-(sp)
		bsr	getchar
		bmi	getnum_error
		cmpi	#'0',d0
		bcs	getnum_error
		cmpi	#'9',d0
		bhi	getnum_error

		moveq	#$f,d1
		and	d0,d1
getnum_loop:
		bsr	getchar
		bmi	getnum_numchar_end2
		cmpi	#'0',d0
		bcs	getnum_numchar_end
		cmpi	#'9',d0
		bhi	getnum_numchar_end
		cmpi.l	#$10000,d1
		bcc	getnum_error

		mulu	#10,d1
		subi	#'0',d0
		add.l	d0,d1
		bra	getnum_loop
getnum_numchar_end:
		bsr	putbackchar
getnum_numchar_end2:
		move.l	d1,d0
		move.l	(sp)+,d1
		cmp.l	d0,d0
		rts
getnum_error:
		move.l	(sp)+,d1
		moveq	#-1,d0
		rts

* Rgs/s𖳎.
* out	d0.l	G[R[h

skip_blank_line_search_lf:
		bsr	getchar
		bmi	skip_blank_line_error
		cmpi	#LF,d0
		bne	skip_blank_line_search_lf
skip_blank_line:
		bsr	getchar
		bmi	skip_blank_line_error
		cmpi	#'#',d0
		beq	skip_blank_line_search_lf
		cmpi	#CR,d0
		beq	skip_blank_line_search_lf
		cmpi	#LF,d0
		beq	skip_blank_line

		bsr	putbackchar
		moveq	#0,d0
skip_blank_line_error:
		rts


* t@C1ǂݍ(}`oCgΉ).
* out	d0.l	R[h

getchar:
		move.l	a0,-(sp)
		tst.l	(WORK_FILECNT,a6)
		beq	getchar_error

		movea.l	(WORK_FILEPTR,a6),a0
		moveq	#0,d0
		move.b	(a0)+,d0
		bpl	getchar_1
		cmpi.b	#$a0,d0
		bcs	getchar_2
		cmpi.b	#$e0,d0
		bcs	getchar_1
getchar_2:
		subq.l	#1,(WORK_FILECNT,a6)
		beq	getchar_2_error		;ʃoCgȂ

		move.b	d0,-(sp)
		move	(sp)+,d0
		move.b	(a0)+,d0
getchar_1:
		subq.l	#1,(WORK_FILECNT,a6)
getchar_2_error:
		move.l	a0,(WORK_FILEPTR,a6)
		cmp.l	d0,d0			;Z=1 N=0
		movea.l	(sp)+,a0
		rts
getchar_error:
		moveq	#-1,d0			;Z=0 N=1
		movea.l	(sp)+,a0
		rts

* ǂݍ1obt@ɖ߂(}`oCgΉ).
* in	d0.l	R[h
* out	d0.l	G[R[h

putbackchar:
		tst.l	d0
		bmi	putbackchar_error
		tst	d0
		bpl	@f
		addq.l	#2,(WORK_FILECNT,a6)
		subq.l	#2,(WORK_FILEPTR,a6)
		moveq	#0,d0
		rts
@@:
		addq.l	#1,(WORK_FILECNT,a6)
		subq.l	#1,(WORK_FILEPTR,a6)
		moveq	#0,d0
		rts
putbackchar_error:
		moveq	#-1,d0
		rts


* TASL \C ----------------------------- *
* WX^a6.lȊOׂĔj󂷂\.

tasl_play_main:
		tst.b	(WORK_OPT_T,a6)
		bne	tasl_play_main_no_title
tasl_play_main_no_inkey:
		DOS	_CHANGE_PR		;^Cg\
		bsr	tasl_play_main_esc_check
		bne	tasl_play_main_end
		IOCS	_B_KEYSNS
		tst.l	d0
		beq	tasl_play_main_no_inkey

		IOCS	_B_KEYINP
		tst.b	d0
		beq	tasl_play_main_no_inkey
tasl_play_main_no_title:
		IOCS	_B_CUROFF

		lea	(txfill_rasblock_clear,pc),a1
		IOCS	_TXFILL
		moveq	#$00_01,d1
		move	#1024/4-1,d2
		moveq	#$00<<8+%1011,d3	;graphic maskʂɕʂ
		IOCS	_TXRASCPY

tasl_play_main_replay:
*		clr.b	(WORK_VDISP_ON,a6)
		clr.b	(WORK_FIRST_FLAG,a6)
		clr.l	(WORK_VDISP_CNT,a6)
		clr.l	(WORK_TOTAL_WAIT,a6)
		clr.l	(WORK_NEXT_WAIT,a6)
tasl_play_main_loop:
		movea.l	(WORK_SCHPTR,a6),a5
tasl_play_main_next:
		cmpa.l	(WORK_SCHEND,a6),a5
		beq	tasl_play_main_enderr	;L[͑҂or[vȂ

tasl_play_main_wait:
		DOS	_CHANGE_PR
		bsr	tasl_play_main_esc_check
		bne	tasl_play_main_end
		tst.b	(WORK_VDISP_ON,a6)
		bne	tasl_play_main_wait	;Õy[W؂ւ҂

		move.l	(SCH_TEXTNUM,a5),d0
		beq	tasl_play_main_command

;ʂ̃eLXgʕ\
		lsl.l	#2,d0
		movea.l	(WORK_TEXTPTR,a6),a0
		move.l	(a0,d0.l),d0
		beq	tasl_play_main_scherr

		movea.l	d0,a0			;a0.l=eLXgf[^
		move.l	(WORK_SKIP_Y,a6),d0
		moveq	#LF,d1
		bra	1f
@@:		cmp.b	(a0)+,d1		;f[^\Yʒȕ
		bne	@b			;(Xʒu͊esƂɏ)
1:		dbra	d0,@b

		move.l	(WORK_SIZE_X,a6),d6
		cmp.l	(WORK_MAX_X,a6),d6
		bls	@f
		move.l	(WORK_MAX_X,a6),d6
@@:		subq	#1,d6			;d6.w=-1

		move.l	(WORK_SIZE_Y,a6),d7
		cmp.l	(WORK_MAX_Y,a6),d7
		bls	@f
		move.l	(WORK_MAX_Y,a6),d7
@@:		subq	#1,d7			;d7.w=s-1

		TO_SUPER
		PUSH	a5-a6
		move	(CRTC_R21),-(sp)
		move	#%01<<8+DRAW_COLOR<<4+DRAW_COLOR,(CRTC_R21)

		movea.l	(WORK_FNTBUF,a6),a4	;a4.l=tHgobt@
		movea.l	(WORK_VTXTBUF,a6),a5	;a5.l=zeLXgobt@

		movea.l	(WORK_MODEPTR,a6),a1
		adda	(TASL_DRAW_TEXT,a1),a1
		jsr	(a1)			;[hƂ̕`惋[`Ăяo

		move	(sp)+,(CRTC_R21)
		POP	a5-a6
		TO_USER

		move.l	(SCH_TIME,a5),(WORK_NEXT_WAIT,a6)
		tas	(WORK_FIRST_FLAG,a6)
		bne	tasl_play_main_text_2

		clr.l	(WORK_VDISP_CNT,a6)	;ꖇڂ̕\n߂
		moveq	#1,d0
		move.l	d0,(WORK_TOTAL_WAIT,a6)
		bra	@f

tasl_play_main_text_2:
		move.l	(WORK_TOTAL_WAIT,a6),d0
		cmp.l	(WORK_VDISP_CNT,a6),d0
		bhi	@f
		addq	#1,(WORK_OVERTIME,a6)	;̃eLXg̕`ɎԂ|߂
		subq.l	#1,d0
		move.l	d0,(WORK_VDISP_CNT,a6)
@@:
		st	(WORK_VDISP_ON,a6)

		addq.l	#sizeof_SCH,a5
		bra	tasl_play_main_next

tasl_play_main_command:
		bsr	tasl_play_main_esc_check
		bne	tasl_play_main_end

		move.l	(SCH_TIME,a5),d0	;@\ԍ
		addq.l	#sizeof_SCH,a5
*		beq	tasl_play_main_command_0
		subq.l	#1,d0
		beq	tasl_play_main_command_1
		bhi	tasl_play_main_cmderr

tasl_play_main_command_0:
		tst.b	(WORK_OPT_X,a6)
		beq	tasl_play_main_command_0_start
		bra	tasl_play_main_command_0_next

tasl_play_main_command_0_wait:
		DOS	_CHANGE_PR
		bsr	tasl_play_main_esc_check
		bne	tasl_play_main_end
tasl_play_main_command_0_start:
		move.l	(WORK_TOTAL_WAIT,a6),d0
		cmp.l	(WORK_VDISP_CNT,a6),d0
		bhi	tasl_play_main_command_0_wait
tasl_play_main_command_0_loop:
		DOS	_CHANGE_PR
		IOCS	_B_KEYSNS
		tst.l	d0
		beq	tasl_play_main_command_0_loop
		IOCS	_B_KEYINP
		cmpi.b	#ESC,d0
		beq	tasl_play_main_end
		cmpi.b	#SPACE,d0
		beq	tasl_play_main_replay
		cmpi.b	#CR,d0
		beq	@f
		cmpi.b	#LF,d0
		bne	tasl_play_main_command_0_loop
@@:
		clr.b	(WORK_FIRST_FLAG,a6)
tasl_play_main_command_0_next:
		cmpa.l	(WORK_SCHEND,a6),a5
		beq	tasl_play_main_end
		bra	tasl_play_main_next

tasl_play_main_command_1:
		tst.b	(WORK_OPT_X,a6)
		beq	tasl_play_main_loop
*		cmpa.l	(WORK_SCHEND,a6),a5
*		bne	tasl_play_main_next	;܂
tasl_play_main_end:
		bsr	tasl_play_main_endjob
		moveq	#0,d0
		rts
tasl_play_main_enderr:
tasl_play_main_scherr:
tasl_play_main_cmderr:
		bsr	tasl_play_main_endjob
		moveq	#-1,d0
		rts

tasl_play_main_endjob:
		clr.b	(WORK_VDISP_ON,a6)
		tst.b	(WORK_TEXTSIDE,a6)
		beq	@f

		move	#(512/4<<8)+0,d1
		moveq	#512/4-1,d2
		moveq	#$00_03,d3
		IOCS	_TXRASCPY
		bsr	init_textside
@@:
		lea	(txfill_rasblock_clear,pc),a1
		move	#$8000+%1011,(0,a1)	;ʂgraphic mask
		move	#512,(4,a1)
		IOCS	_TXFILL

		move	#(512/4<<8)+(512/4+1),d1
		moveq	#512/4-1,d2
		moveq	#$00<<8+%1011,d3	;V
		IOCS	_TXRASCPY

		bsr	tasl_play_main_kflush
		IOCS	_B_CURON
		rts

tasl_play_main_kflush_loop:
		IOCS	_B_KEYINP
tasl_play_main_kflush:
		IOCS	_B_KEYSNS
		tst.l	d0
		bne	tasl_play_main_kflush_loop
		rts

* ESCL[ĂȂ`FbN.
* out	d0.l	0:ĂȂ -1:Ă

tasl_play_main_esc_check:
		IOCS	_B_KEYSNS
		cmpi.b	#ESC,d0
		beq	@f
		move.l	d1,-(sp)
		moveq	#0,d1
		IOCS	_BITSNS
		move.l	(sp)+,d1
		lsr.b	#2,d0
		bcs	@f
		moveq	#0,d0
		rts
@@:		moveq	#-1,d0
		rts


*V-DISP荞ݏ
vdisp_int_entry:
		PUSH	d0-d3/a6
		lea	(work,pc),a6
		addq.l	#1,(WORK_VDISP_CNT,a6)
		bne	@f
		subq.l	#1,(WORK_VDISP_CNT,a6)
@@:		tst.b	(WORK_VDISP_ON,a6)
		beq	vdisp_int_skip

		move.l	(WORK_TOTAL_WAIT,a6),d0
		cmp.l	(WORK_VDISP_CNT,a6),d0
		bhi	vdisp_int_skip

		clr.b	(WORK_VDISP_ON,a6)
		moveq	#8,d1
		moveq	#0,d2
		moveq	#0,d3
		not.b	(WORK_TEXTSIDE,a6)	;x\(0:\ -1:)
		beq	@f
		move	#512,d3
@@:		IOCS	_SCROLL

		move.l	(WORK_NEXT_WAIT,a6),d0
		add.l	d0,(WORK_TOTAL_WAIT,a6)	;\y[W̏I
		bcc	vdisp_int_skip
		moveq	#-1,d0
		move.l	d0,(WORK_TOTAL_WAIT,a6)
vdisp_int_skip:
		POP	d0-d3/a6
		rte


* Subroutine ---------------------------------- *

GetArgChar:
		movem.l	d1/a1,-(sp)
		moveq	#0,d0
		move.b	(ArgPtr,a6),d0
		movea.l	(ArgPtr,a6),a1
GetArgChar_quate:
		move.b	d0,d1
GetArgChar_next:
		move.b	(a1)+,d0
		beq	GetArgChar_abort
		tst.b	d1
		bne	GetArgChar_inquate
		cmpi.b	#' ',d0
		beq	GetArgChar_separate
		cmpi.b	#"'",d0
		beq	GetArgChar_quate
		cmpi.b	#'"',d0
		beq	GetArgChar_quate
GetArgChar_end:
		move.l	a1,(ArgPtr,a6)
		move.b	d1,(ArgPtr,a6)
GetArgChar_abort:
		movem.l	(sp)+,d1/a1
		rts
GetArgChar_inquate:
		cmp.b	d0,d1
		bne	GetArgChar_end
		clr.b	d1
		bra	GetArgChar_next
GetArgChar_separate:
		cmp.b	(a1)+,d0
		beq	GetArgChar_separate
		subq.l	#1,a1
		moveq	#1,d0
		ror.l	#1,d0
		bra	GetArgChar_end

GetArgCharInit:
		move.l	a1,-(sp)
		movea.l	(8,sp),a1
GetArgCharInit_skip:
		cmpi.b	#' ',(a1)+
		beq	GetArgCharInit_skip
		subq.l	#1,a1
		move.l	a1,(ArgPtr,a6)
		movea.l	(sp)+,a1
		rts

GetEnvPtr:
		movem.l	d1/a0-a3,-(sp)
		movea.l	(24,sp),a0
		move.l	(28,sp),d0
		bne	@f

		DOS	_GETPDB
		movea.l	d0,a1
		move.l	(16-16,a1),d0
@@:
		moveq	#-1,d1
		cmp.l	d0,d1
		beq	GetEnvPtr_error

		movea.l	d0,a1
		tst.l	(a1)+
		beq	GetEnvPtr_error

		lea	(a0),a2
@@:		tst.b	(a2)+
		bne	@b
		move.l	a2,d1
		subq.l	#1,d1
		sub.l	a0,d1
		subq.l	#1,d1
		bcs	GetEnvPtr_error
GetEnvPtr_next:
		lea	(a1),a3
		tst.b	(a1)+
		beq	GetEnvPtr_error
@@:		tst.b	(a1)+
		bne	@b
		move.l	a1,d0
		subq.l	#1,d0
		sub.l	a3,d0

		cmp.l	d1,d0
		bcs	GetEnvPtr_next
		cmpi.b	#'=',(1,d1.l,a3)
		bne	GetEnvPtr_next

		lea	(a0),a2
		move.l	d1,d0
@@:		cmp.b	(a2)+,(a3)+
		dbne	d0,@b
		bne	GetEnvPtr_next
		clr	d0
		subq.l	#1,d0
		bcc	@b

		addq.l	#1,a3
		move.l	a3,d0
@@:
		movem.l	(sp)+,d1/a0-a3
		rts
GetEnvPtr_error:
		moveq	#-1,d0
		bra	@b


* Data Section -------------------------------- *

		.data
		.even

crtc_640x400_data:
		.dc	116,11,19,99,440,6,32,432

txfill_rasblock_clear:
		.dc	$8000+%0011
		.dc	0,0,1024,4
		.dc	$00_00

title_mes:
		.dc.b	CRLF
		.dc.b	program,' version ',version,SPACE,date,SPACE,author,'.',CRLF,0
usage_mes:
		.dc.b	'usage: tasl [option] [filename]',CRLF
		.dc.b	'option:',CRLF
		.dc.b	' -c<n>[,<n2>]	\Fw(n=0-7)',CRLF
*		.dc.b	' -d+		{[h[W]',CRLF
*		.dc.b	' -d[-]		fobO[h',CRLF
		.dc.b	' -f+		IɃt@NVL[\[W]',CRLF
		.dc.b	' -f[-]		IɃt@NVL[\Ȃ',CRLF
		.dc.b	' -g+		Đ̓OtBbN\[W]',CRLF
		.dc.b	' -g[-]		Đ̓OtBbN\',CRLF
		.dc.b	' -l<n>		fBXvCg(n=0:31kHz[W] n=1:24kHz)',CRLF
		.dc.b	' -m<n>		Đ[h(n=0:96x32 n=1:192x64[W] n=2:128x96[])',CRLF
		.dc.b	' -oc		ʒɕ\[W]',CRLF
		.dc.b	' -o		f[^wʒuɕ\',CRLF
		.dc.b	' -ox,y		\ʒuw',CRLF
		.dc.b	' -p<n>[,<n2>]	\Fpbgw',CRLF
		.dc.b	' -r+		ʏ\[W]',CRLF
		.dc.b	' -r[-]		]\',CRLF
		.dc.b	' -s<n>		X[Đ',CRLF
		.dc.b	' -t+		^Cg\[W]',CRLF
		.dc.b	' -t[-]		^Cg\Ȃ',CRLF
		.dc.b	' -x+		IȂ[W]',CRLF
		.dc.b	' -x[-]		I',CRLF
		.dc.b	CRLF
		.dc.b	'note: R}hCɊϐ TASL ]܂.',CRLF
		.dc.b	CRLF
		.dc.b	0

envname_tasl:
		.dc.b	'TASL',0
complete_ext_tsl:
		.dc.b	'.tsl',0
tasl_mes:
		.dc.b	'tasl: ',0
overtime_mes:
		.dc.b	'tasl:  = ',0
crlf_mes:
		.dc.b	CRLF,0

seek_error_mes:
		.dc.b	'seek error.',CRLF,0
read_error_mes:
		.dc.b	'read error.',CRLF,0
setblock_error_mes:
*		.dc.b	'setblock error.',CRLF,0
malloc_error_mes:
		.dc.b	'܂.',CRLF,0
filename_error_mes:
		.dc.b	't@Cُł.',CRLF,0
open_error_mes:
		.dc.b	't@CI[vo܂.',CRLF,0

color_error_mes:
palette_error_mes:
		.dc.b	'F̎w肪sł.',CRLF,0
display_error_mes:
		.dc.b	'𑜓x[h̎w肪sł.',CRLF,0
mode_error_mes:
		.dc.b	'\[h̎w肪sł.',CRLF,0
slow_error_mes:
		.dc.b	'EFCg{sł.',CRLF,0
offset_error_mes:
		.dc.b	'\ʒu̎w肪sł.',CRLF,0

play_error_mes:
sch_error_mes:
		.dc.b	'XPW[ُł.',CRLF,0
text_error_mes:
		.dc.b	'V[f[^ُł.',CRLF,0
version_error_mes:
		.dc.b	'Ή̃o[Wł.',CRLF,0
header_error_mes:
		.dc.b	'wb_ُł.',CRLF,0
clipping_error_mes:
		.dc.b	'\ʒuُł.',CRLF,0
title_error_mes:
		.dc.b	'^Cgُł.',CRLF,0

	.if	0
close_error_mes:
		.dc.b	'close error.',CRLF,0
mfree_error_mes:
		.dc.b	'mfree error.',CRLF,0
	.endif


* Block Storage Section ----------------------- *

		.bss
		.even
work:
*		.ds.b	sizeof_WORK


		.end

* End of File --------------------------------- *
